*scroll 6ms each
*or 11ms 

****************************************************************************
****************************************************************************
**                                                               
**  Mercury for TI-89 / TI-92 Plus
**
**  This software is in the public domain.  There is no warranty.
**
**  by Patrick Davidson (pad@calc.org, http://pad.calc.org/)
**
**  Last updated August 16, 2002
**                                      
****************************************************************************
****************************************************************************

*************************************** MASK (A1/A0) over (A2/A3)

MASK_LONG MACRO
        move.l  BUFFER_SIZE(a1),d0
        move.l  (a1)+,d1
        move.l  d0,d2
        or.l    d1,d2                   ; D2 = mask to black
        move.l  d2,d3
        or.l    BUFFER_SIZE(a0),d2
        or.l    (a0)+,d3
        eor.l   d0,d2
        eor.l   d1,d3
        move.l  d2,(a2)+
        move.l  d3,(a3)+
        ENDM

*************************************** SCROLL AND DRAW BACKGROUND

Scroll_Screen:
        tst.w   open_space(a5)
        blt.s   scroll_space
        bgt.s   stationary

*************************************** SCROLLING BOTH PLANES

        addq.w  #1,fg_x(a5)
        bsr     Scroll_FG_Left          ; foreground left 1
        btst    #0,fg_x+1(a5)
        beq.s   \sd                     ; if even pixel, skip background           
        addq.w  #1,bg_x(a5)             ; background left 1
        bsr     Scroll_BG_Left
\sd:    bra     Build_Main_Screen

*************************************** SCROLLING BACKGROUND ONLY

scroll_space:
        bclr    #3,fg_x+1(a5)           ; keep foreground x in 0..7
        addq.w  #1,fg_x(a5)             ; increment foreground x
        btst    #0,fg_x+1(a5)           ; if even pixel, don't scroll 
        beq.s   stationary              
        addq.w  #1,bg_x(a5)             ; background left 1
        bsr     Scroll_BG_Left

*************************************** NO SCROLLING

stationary:
        bsr     Build_Main_Screen       ; display screen
        tst.w   enemycount(a5)          ; if no enemies, back to normal
        bne.s   \gc
        clr.w   open_space(a5)
\gc:    rts

*************************************** BUILD MAIN SCREEN

Build_Main_Screen:
        move.l  backbuffer(a5),a1       ; A1 -> foreground
    IFD ti89
        move.w  screeny(a5),d0
        sub.w   #64,d0
        mulu    #BUFFER_WIDTH,d0
        add.w   d0,a1
    ENDIF
        lea     s(a5),a2
        lea     PLANE_SIZE(a2),a3
        lea     BUFFER_SIZE*2(a1),a0    ; A0 -> background

        moveq   #SCR_HEIGHT-1,d7
\l:     MASK_LONG
        MASK_LONG
        MASK_LONG
        MASK_LONG
        MASK_LONG
    IFND ti89
        MASK_LONG
    ENDIF
        addq.w  #2,a0
        addq.w  #2,a1
        dbra    d7,\l
        rts

*************************************** SCROLL FOREGROUND LEFT

Scroll_FG_Left:
        move.l  backbuffer(a5),a0
        lea     BUFFER_SIZE*2(a0),a0

        move.w  #(BUFFER_SIZE*2)/32-1,d0
\l:     roxl.w  -(a0)
        roxl.w  -(a0)
        roxl.w  -(a0)
        roxl.w  -(a0)
        roxl.w  -(a0)
        roxl.w  -(a0)
        roxl.w  -(a0)
        roxl.w  -(a0)
        roxl.w  -(a0)
        roxl.w  -(a0)
        roxl.w  -(a0)
        roxl.w  -(a0)
        roxl.w  -(a0)
        roxl.w  -(a0)
        roxl.w  -(a0)
        roxl.w  -(a0)
        dbra    d0,\l
        move.w  fg_x(a5),d0
        and.w   #15,d0
        bne.s   \n

*************************************** RESTART IF PAST END

        move.w  fg_x(a5),d0
        bsr     Get_Level_Width
        lsl.w   #4,d6
        cmp.w   d6,d0
        bne.s   \no_restart

   IFND ti89
        move.l  a0,-(sp)
        lea     bcd_level+4(a5),a1
        lea     one(pc),a0
        moveq   #1,d5
        bsr     Add_BCD
        move.l  (sp)+,a0
   ENDIF

        addq.w  #1,level(a5)
        bsr     Get_Level_Width
        bne.s   \nb
        clr.w   level(a5)
\nb:

        moveq   #0,d0
        move.w  d0,fg_x(a5)
\no_restart:

*************************************** IF ON COLUMN BOUNDARY, DRAW NEXT ONE

        lsr.w   #4,d0
        bsr     Get_Level_Map
        add.w   d0,a1
        lea     FG_til(pc),a2
        bsr     Get_Level_Width
        lea     BUFFER_WIDTH-2(a0),a0
        bsr     Draw_Column
        clr.w   d1
        move.b  (a1),d1
        bra     Handle_Events
\n:     rts

*************************************** SCROLL BACKGROUND LEFT

Scroll_BG_Left:
        move.l  backbuffer(a5),a0
        lea     BUFFER_SIZE*4(a0),a0

        move.w  #(BUFFER_SIZE*2)/32-1,d0
\l:     roxl.w  -(a0)
        roxl.w  -(a0)
        roxl.w  -(a0)
        roxl.w  -(a0)
        roxl.w  -(a0)
        roxl.w  -(a0)
        roxl.w  -(a0)
        roxl.w  -(a0)
        roxl.w  -(a0)
        roxl.w  -(a0)
        roxl.w  -(a0)
        roxl.w  -(a0)
        roxl.w  -(a0)
        roxl.w  -(a0)
        roxl.w  -(a0)
        roxl.w  -(a0)
        dbra    d0,\l

*************************************** IF ON COLUMN BOUNDARY, DRAW NEXT ONE

        move.w  bg_x(a5),d0
        and.w   #15,d0
        bne.s   \n
        move.w  bg_x(a5),d0
        lsr.w   #4,d0
        and.w   #7,d0
        lea     BG_map(pc),a1
        add.w   d0,a1
        lea     BG_til(pc),a2
        moveq   #8,d6
        lea     BUFFER_WIDTH-2(a0),a0
        bra     Draw_Column
\n:     rts

*************************************** INVERT FOREGROUND (TO MASK ON BLACK)

Invert_FG:
        lea     FG_til(pc),a0
        lea     BG_map(pc),a1
\i:     not.l   (a0)+
        cmp.l   a0,a1
        bne.s   \i
        rts

*************************************** CLEAR BACKGROUND DATA

Zero_Foreground:
        move.l  backbuffer(a5),a0
        move.w  #BUFFER_SIZE/2-1,d0
\s:     clr.l   (a0)+
        dbra    d0,\s
        rts  

*************************************** REDRAW TILES

Redraw_Foreground:
        bsr     Zero_Foreground

        lea     FG_til(pc),a2           ; A2 -> tile data
        move.l  backbuffer(a5),a0
        add.w   #BUFFER_WIDTH-2,a0      ; A0 -> column to draw in
        move.w  fg_x(a5),d7
        blt.s   \q
        lsr.w   #4,d7                   ; D7 = column #
        bsr     Get_Level_Width         ; D6 = map width
        moveq   #(BUFFER_WIDTH/2)-1,d5  ; D5 = # columns remaining
\rfl:   bsr     Get_Level_Map
        add.w   d7,a1                   ; A1 -> map data
        bsr     Draw_Column
        lea     -2-BUFFER_SIZE(a0),a0   ; shift to previous column
        subq.w  #1,d7
        dblo    d5,\rfl

        move.w  fg_x(a5),d7
        and.w   #15,d7
        subq.w  #1,d7   
        blt.s   \q
\slide: bsr     Scroll_FG_Left
        dbra    d7,\slide
\q:     rts

Redraw_Background:
        lea     BG_til(pc),a2           ; A2 -> tile data
        move.l  backbuffer(a5),a0
        add.w   #BUFFER_SIZE*2+BUFFER_WIDTH-2,a0
        move.w  bg_x(a5),d7
        lsr.w   #4,d7                   ; D7 = column #
        moveq   #8,d6                   ; D6 = map width
        moveq   #(BUFFER_WIDTH/2)-1,d5  ; D5 = # columns remaining
\rfl:   lea     BG_map(pc),a1
        and.w   #7,d7
        add.w   d7,a1                   ; A1 -> map data
        bsr     Draw_Column
        lea     -2-BUFFER_SIZE(a0),a0   ; shift to previous column
        subq.w  #1,d7
        dbra    d5,\rfl

        move.w  bg_x(a5),d7
        and.w   #15,d7
        subq.w  #1,d7   
        blt.s   \q
\slide: bsr     Scroll_BG_Left
        dbra    d7,\slide
\q:     rts

*************************************** DRAW ONE COLUMN OF MAP
*
* Draws one column (full 128 lines) of the map into the buffer.  Inputs:
*
* A1 -> first byte of this column in the map
* D6 = width of map in bytes
* A2 -> tile set
* A0 -> first word of this column in buffer
*
* Modifies D0, D1, A0, A1, and A3.
*
********

Draw_Column:                                
        moveq   #7,d0
\a:     move.b  (a1),d1
        add.w   d6,a1
        ext.w   d1
        lsl.w   #6,d1
        lea     0(a2,d1.w),a3
        moveq   #15,d1
\c:     move.w  32(a3),BUFFER_SIZE(a0)
        move.w  (a3)+,(a0)
        lea     BUFFER_WIDTH(a0),a0
        dbra    d1,\c
        dbra    d0,\a
        rts

*************************************** TILE/STAR DATA

FG_til: INCLUDE maps\ftile.i
BG_map: INCLUDE maps\bmap.i
BG_til: INCLUDE maps\btile.i

*************************************** LEVEL (FORGROUND/CONTROL) DATA

Get_Level_Map:
        move.w  level(a5),d1
        add.w   d1,d1
        add.w   d1,d1
        move.w  Level_Data+2(pc,d1.w),d1
        lea     Level_Data(pc,d1.w),a1
        rts

Get_Level_Width:
        move.w  level(a5),d6
        add.w   d6,d6
        add.w   d6,d6
        move.w  Level_Data(pc,d6.w),d6
        rts

Level_Data:
        dc.w    117,map1-Level_Data
        dc.w    98,map2-Level_Data
        dc.w    25,map3-Level_Data
        dc.w    0

map1:   INCLUDE maps\fmap.i
map2:   INCLUDE maps\fmap2.i
map3:   INCLUDE maps\fmap3.i
        EVEN
