****************************************************************************
****************************************************************************
**                                                               
**  Mercury (Player/item hits)
**
**  This software is in the public domain.  There is no warranty.
**
**  by Patrick Davidson (pad@calc.org, http://pad.calc.org/)
**
**  Last updated August 15, 2002
**
****************************************************************************
****************************************************************************

******************************************** HANDLE ITEM COLLECTION / HIT
*
* These routines are called when the player collides with an enemy
* bullet or bonus.  The routine should damage the ship or add the bonus
* item as appropriate.  The routine is called with A4 pointing to the
* enemy bullet structure, and must preserve A4 and D7.
*
********

Bullet_Hit:
        lea     eb_dmg+2(a4),a0
Damage_Player:
        lea     player_dmg+2(a5),a1
        moveq   #1,d5
        bsr     Sub_BCD
        bcc.s   \ok
        clr.w   player_dmg(a5)
        st      show_end(a5)
\ok:    rts

Shield_Bonus:
        cmp.w   #$100,player_dmg(a5)
        bge.s   \ok
        lea     player_dmg+2(a5),a1
        lea     ten+2(pc),a0
        moveq   #1,d5
        bsr     Add_BCD
        cmp.w   #$100,player_dmg(a5)
        ble.s   \ok
        move.w  #$100,player_dmg(a5)
\ok:    rts

Score_Bonus:
        lea     score+4(a5),a1          ; add 25 to score
        lea     twohundred+4(pc),a0
        moveq   #3,d5
        bra     Add_BCD

ten:    dc.w    $0010

Energy_Bonus:   
        cmp.w   #16,generation(a5)
        bge.s   \done
        addq.w  #1,generation(a5)
\done:  rts

twohundred:
        dc.l    $00000200

Weapon_2_Bonus:
        move.w  #4,player_weapon(a5)
        rts

Weapon_3_Bonus:
        move.w  #8,player_weapon(a5)
        rts

Weapon_4_Bonus:
        move.w  #12,player_weapon(a5)
        rts

********************************************** ITEM HIT TYPES
*
* The ITEMHIT macro assigns an item hit type for each type of item used in
* the game.  The first argument is the symbol that is created for the
* type, and the second is the hit code.  The item hit type is a relative
* pointer, and is used in the eb_hit field of the enemy bullet array.
*
* As this table is only used to set symbols to equal the offsets, this table
* takes absolutely no space in the executable code.
*
*******

ITEMHIT MACRO   
\1      equ     \2-Enemy_Bullets        
        ENDM
                       
        ITEMHIT H_BULLET,Bullet_Hit
        ITEMHIT H_SHIELD,Shield_Bonus
        ITEMHIT H_POINTS,Score_Bonus
        ITEMHIT H_ENERGY,Energy_Bonus
        ITEMHIT H_WEAPON2,Weapon_2_Bonus
        ITEMHIT H_WEAPON3,Weapon_3_Bonus
        ITEMHIT H_WEAPON4,Weapon_4_Bonus
